import 'package:analyzer_plugin/channel/channel.dart';
import 'package:analyzer/src/generated/sdk.dart';
import 'package:analyzer/src/dart/analysis/performance_logger.dart';
import 'package:analyzer/src/dart/analysis/file_state.dart';
import 'package:analyzer/src/dart/analysis/driver.dart';
import 'package:analyzer/src/dart/analysis/byte_store.dart';
import 'package:analyzer/file_system/file_system.dart';
import 'package:analyzer/dart/analysis/results.dart';
import 'package:analyzer_plugin/plugin/plugin.dart';
import 'package:pub_semver/src/version.dart';
import 'package:analyzer_plugin/utilities/subscriptions/subscription_manager.dart';
import 'package:analyzer_plugin/protocol/protocol_generated.dart';

/// 本类仅仅为了翻译插件可重载方法
class RAssetsPlugin implements ServerPlugin {
  /// 调度器，这个调度器被用于所有的分析驱动器
  @override
  AnalysisDriverScheduler analysisDriverScheduler;

  /// 返回任何创建的分析驱动程序使用的字节存储，
  /// 如果由于尚未收到“plugin.version”请求，缓存位置未知，则返回 null。
  @override
  ByteStore get byteStore => throw UnimplementedError();

  /// 返回用于与分析服务器通信的通信通道，如果插件尚未启动，则返回 null。
  @override
  PluginCommunicationChannel get channel => throw UnimplementedError();

  /// 如果 发现任何问题 null，或者
  /// 如果没有联系信息，则返回有关如何联系插件作者的用户可见信息。
  @override
  String get contactInfo => throw UnimplementedError();

  /// 文件修改执行
  @override
  void contentChanged(String path) {}

  /// 返回包含给定文件（filePath）的contextRoot
  @override
  ContextRoot contextRootContaining(String filePath) {
    throw UnimplementedError();
  }

  /// 创建一个分析驱动程序，可以分析给定 contextRoot.
  @override
  AnalysisDriverGeneric createAnalysisDriver(ContextRoot contextRoot) {
    // TODO: implement createAnalysisDriver
    throw UnimplementedError();
  }

  @override
  AnalysisDriverGeneric driverForPath(String path) {
    // TODO: implement driverForPath
    throw UnimplementedError();
  }

  @override
  // TODO: implement driverMap
  Map<ContextRoot, AnalysisDriverGeneric> get driverMap => throw UnimplementedError();

  @override
  // TODO: implement fileContentOverlay
  FileContentOverlay get fileContentOverlay => throw UnimplementedError();

  @override
  // TODO: implement fileGlobsToAnalyze
  List<String> get fileGlobsToAnalyze => throw UnimplementedError();

  @override
  Future<ResolvedUnitResult> getResolvedUnitResult(String path) {
    // TODO: implement getResolvedUnitResult
    throw UnimplementedError();
  }

  @override
  Future<AnalysisGetNavigationResult> handleAnalysisGetNavigation(AnalysisGetNavigationParams params) {
    // TODO: implement handleAnalysisGetNavigation
    throw UnimplementedError();
  }

  @override
  Future<AnalysisHandleWatchEventsResult> handleAnalysisHandleWatchEvents(AnalysisHandleWatchEventsParams parameters) {
    // TODO: implement handleAnalysisHandleWatchEvents
    throw UnimplementedError();
  }

  @override
  Future<AnalysisSetContextRootsResult> handleAnalysisSetContextRoots(AnalysisSetContextRootsParams parameters) {
    // TODO: implement handleAnalysisSetContextRoots
    throw UnimplementedError();
  }

  @override
  Future<AnalysisSetPriorityFilesResult> handleAnalysisSetPriorityFiles(AnalysisSetPriorityFilesParams parameters) {
    // TODO: implement handleAnalysisSetPriorityFiles
    throw UnimplementedError();
  }

  @override
  Future<AnalysisSetSubscriptionsResult> handleAnalysisSetSubscriptions(AnalysisSetSubscriptionsParams parameters) {
    // TODO: implement handleAnalysisSetSubscriptions
    throw UnimplementedError();
  }

  @override
  Future<AnalysisUpdateContentResult> handleAnalysisUpdateContent(AnalysisUpdateContentParams parameters) {
    // TODO: implement handleAnalysisUpdateContent
    throw UnimplementedError();
  }

  @override
  Future<CompletionGetSuggestionsResult> handleCompletionGetSuggestions(CompletionGetSuggestionsParams parameters) {
    // TODO: implement handleCompletionGetSuggestions
    throw UnimplementedError();
  }

  @override
  Future<EditGetAssistsResult> handleEditGetAssists(EditGetAssistsParams parameters) {
    // TODO: implement handleEditGetAssists
    throw UnimplementedError();
  }

  @override
  Future<EditGetAvailableRefactoringsResult> handleEditGetAvailableRefactorings(
      EditGetAvailableRefactoringsParams parameters) {
    // TODO: implement handleEditGetAvailableRefactorings
    throw UnimplementedError();
  }

  @override
  Future<EditGetFixesResult> handleEditGetFixes(EditGetFixesParams parameters) {
    // TODO: implement handleEditGetFixes
    throw UnimplementedError();
  }

  @override
  Future<EditGetRefactoringResult> handleEditGetRefactoring(EditGetRefactoringParams parameters) {
    // TODO: implement handleEditGetRefactoring
    throw UnimplementedError();
  }

  @override
  Future<KytheGetKytheEntriesResult> handleKytheGetKytheEntries(KytheGetKytheEntriesParams parameters) {
    // TODO: implement handleKytheGetKytheEntries
    throw UnimplementedError();
  }

  @override
  Future<PluginShutdownResult> handlePluginShutdown(PluginShutdownParams parameters) {
    // TODO: implement handlePluginShutdown
    throw UnimplementedError();
  }

  @override
  Future<PluginVersionCheckResult> handlePluginVersionCheck(PluginVersionCheckParams parameters) {
    // TODO: implement handlePluginVersionCheck
    throw UnimplementedError();
  }

  @override
  bool isCompatibleWith(Version serverVersion) {
    // TODO: implement isCompatibleWith
    throw UnimplementedError();
  }

  @override
  // TODO: implement name
  String get name => throw UnimplementedError();

  @override
  void onDone() {
    // TODO: implement onDone
  }

  @override
  void onError(Object exception, StackTrace stackTrace) {
    // TODO: implement onError
  }

  @override
  // TODO: implement performanceLog
  PerformanceLog get performanceLog => throw UnimplementedError();

  /// 用于访问文件系统的资源提供程序。
  @override
  ResourceProvider get resourceProvider => throw UnimplementedError();

  @override
  // TODO: implement sdkManager
  DartSdkManager get sdkManager => throw UnimplementedError();

  @override
  Future<void> sendFoldingNotification(String path) {
    // TODO: implement sendFoldingNotification
    throw UnimplementedError();
  }

  @override
  Future<void> sendHighlightsNotification(String path) {
    // TODO: implement sendHighlightsNotification
    throw UnimplementedError();
  }

  @override
  Future<void> sendNavigationNotification(String path) {
    // TODO: implement sendNavigationNotification
    throw UnimplementedError();
  }

  @override
  void sendNotificationsForFile(String path) {
    // TODO: implement sendNotificationsForFile
  }

  @override
  void sendNotificationsForSubscriptions(Map<String, List<AnalysisService>> subscriptions) {
    // TODO: implement sendNotificationsForSubscriptions
  }

  @override
  Future<void> sendOccurrencesNotification(String path) {
    // TODO: implement sendOccurrencesNotification
    throw UnimplementedError();
  }

  @override
  Future<void> sendOutlineNotification(String path) {
    // TODO: implement sendOutlineNotification
    throw UnimplementedError();
  }

  @override
  void start(PluginCommunicationChannel channel) {
    // TODO: implement start
  }

  @override
  // TODO: implement subscriptionManager
  SubscriptionManager get subscriptionManager => throw UnimplementedError();

  @override
  // TODO: implement version
  String get version => throw UnimplementedError();
}
