//<editor-fold desc="转换图片类型">
import 'dart:io';

import 'package:path/path.dart' as Path;

import '../template_string.dart';

const _tCodeFont = """
  /// font family: {#familyName#}
  // ignore: non_constant_identifier_names
  final {#familyName#} = "{#familyName#}";
""";

/// 规范规则：
///
/// 必须二级路径以上，
///
/// xxxx/xxxx/familyName/*.ttf
///
/// 为了驼峰命名规范，使用下划线分割单词为好"aaa_bbb"
MateFont convertFont(File file) {
  var res = MateFont();
  res.assetFilePath = file.path;
  final tFont = TemplateString(_tCodeFont);
  var fakePath = file.path.replaceAll(Path.basename(file.path), '');
  res.generatedVarName = convertVarName(fakePath);

  res.generatedCode4FamilyName = tFont.format(<String, dynamic>{
    'familyName': res.generatedVarName,
  });
  return res;
}

class MateFont {
  String assetFilePath;
  String generatedVarName;
  String generatedCode4FamilyName;

  @override
  String toString() {
    return 'MateFont{assetFilePath: $assetFilePath, generatedVarName: $generatedVarName}';
  }

  @override
  bool operator ==(Object other) {
    return other is MateFont && other.assetFilePath == this.assetFilePath;
  }

  @override
  int get hashCode => assetFilePath.hashCode;
}
//</editor-fold>
