import 'dart:io';

import '../template_string.dart';

const _tCodeIcon = """  /// asset: {#filePath#}
  // ignore: non_constant_identifier_names
  Widget get {#varNameWithoutSvg#} => SvgPicture.asset(R.svg.{#varName#}(width: 28, height: 28).asset);
  // ignore: non_constant_identifier_names
  Widget get {#varNameWithoutSvg#}Large => SvgPicture.asset(R.svg.{#varName#}(width: 44, height: 44).asset);
  // ignore: non_constant_identifier_names
  Widget get {#varNameWithoutSvg#}Larger => SvgPicture.asset(R.svg.{#varName#}(width: 52, height: 52).asset);
  // ignore: non_constant_identifier_names
  Widget get {#varNameWithoutSvg#}Largest => SvgPicture.asset(R.svg.{#varName#}(width: 68, height: 68).asset);
  // ignore: non_constant_identifier_names
  Widget get {#varNameWithoutSvg#}Small => SvgPicture.asset(R.svg.{#varName#}(width: 24, height: 24).asset);
  // ignore: non_constant_identifier_names
  Widget get {#varNameWithoutSvg#}Smaller => SvgPicture.asset(R.svg.{#varName#}(width: 20, height: 20).asset);
  // ignore: non_constant_identifier_names
  Widget get {#varNameWithoutSvg#}Smallest => SvgPicture.asset(R.svg.{#varName#}(width: 16, height: 16).asset);
  // ignore: non_constant_identifier_names
  Widget get {#varNameWithoutSvg#}Tiny => SvgPicture.asset(R.svg.{#varName#}(width: 12, height: 12).asset);
""";

//<editor-fold desc="转换Icon类型">
MateIcon convertIcon(File file) {
  var res = MateIcon();
  res.assetFilePath = file.path;
  final tIcon = TemplateString(_tCodeIcon);
  res.generatedVarName = convertVarName(file.path);
  res.generatedCode4Icon = tIcon.format(<String, dynamic>{
    "filePath": file.path,
    'varName': res.generatedVarName,
    'varNameWithoutSvg': res.generatedVarName.replaceAll(RegExp(r'Svg$'), ''),
  });
  return res;
}

class MateIcon {
  String assetFilePath;
  String generatedVarName;
  String generatedCode4Icon;

  @override
  String toString() {
    return 'MateImage{assetFilePath: $assetFilePath, generatedVarName: $generatedVarName}';
  }

  @override
  bool operator ==(Object other) {
    return other is MateIcon && other.generatedVarName == this.generatedVarName;
  }

  @override
  int get hashCode => generatedVarName.hashCode;
}
//</editor-fold>
