//<editor-fold desc="转换图片类型">
import 'dart:io';

import '../template_string.dart';

const _tCodeImageAssetResource = """  /// asset: {#filePath#}
  // ignore: non_constant_identifier_names
  final {#varName#} = const AssetResource("{#filePath#}", packageName: R.package);
""";

const _tCodeImage = """  /// asset: {#filePath#}
  // ignore: non_constant_identifier_names
  AssetImage {#varName#}() {
    return AssetImage(asset.{#varName#}.keyName);
  }
""";

///
MateImage convertImage(File file) {
  var res = MateImage();
  res.assetFilePath = file.path;
  final tAsset = TemplateString(_tCodeImageAssetResource);
  final tImage = TemplateString(_tCodeImage);
  res.generatedVarName = convertVarName(file.path);
  res.generatedCode4Asset = tAsset.format(<String, dynamic>{
    "filePath": file.path,
    'varName': res.generatedVarName,
  });
  res.generatedCode4Image = tImage.format(<String, dynamic>{
    "filePath": file.path,
    'varName': res.generatedVarName,
  });
  return res;
}

class MateImage {
  String assetFilePath;
  String generatedVarName;
  String generatedCode4Asset;
  String generatedCode4Image;

  @override
  String toString() {
    return 'MateImage{assetFilePath: $assetFilePath, generatedVarName: $generatedVarName}';
  }

  @override
  bool operator ==(Object other) {
    return other is MateImage && other.generatedVarName == this.generatedVarName;
  }

  @override
  int get hashCode => generatedVarName.hashCode;
}
//</editor-fold>
